#!/bin/bash
# Bash Script for formatting USB drives by GNUger and SSi

clear
echo "WARNING: THIS BASH SCRIPT CAN WIPE THE WRONG DRIVE IF USED INCORRECTLY!"
echo "USE AT YOUR OWN RISK!"
echo

if [[ $EUID -ne "0" ]]
then
 echo "You must be root - try:   sudo $0 or sudo bash $0"
exit 1
fi

echo ""
df | grep '/dev/sd'
echo ""
read -p "Enter partition name (e.g. /dev/sdc1 ) : " device
DD="${device:0:8}"
if [ "$DD" == "/dev/sda" ];
then
echo ""
echo "WARNING: $device may be your internal hard disk!"
echo ""
fi

DD1="${device:0:7}"
if [ "$DD1" == "/dev/sd" ];
then
echo ""
else
echo "Bad device - must start with /dev/sd"
exit 1
fi
GOOD=0
dd if=$DD count=1 skip=60 2> /dev/null | grep 'helper' > /dev/null && GOOD=60
dd if=$DD count=1 skip=30 2> /dev/null | grep 'helper' > /dev/null && GOOD=30
dd if=$DD count=1 skip=0  2> /dev/null | grep 'helper' > /dev/null || GOOD=0
if [[ $GOOD == '0' ]] || [[ $GOOD == '' ]]
 then
 echo "ERROR: NO BACKUP MBR FOUND IN LBA30 or LBA60 on $DD"
 read
 exit 1
else
 ask=N
 read -p "Restore E2B partitions on $DD (Y/[N]) : " ask
 if [[ "$ask" == "y" ]] || [[ "$ask" ==  "Y" ]]
  then
  echo Restoring MBR from backup found at sector $GOOD
  dd if=$DD of=$DD skip=$GOOD seek=0 count=1 2> /dev/null && echo E2B MBR restored OK - please reboot.
  read
 fi
fi


