@echo off
REM Revised for Windows 10 1607 due to vbscript bug
cls
:: MakeAdminShortCut.vbs assumes the target cmd file is in the same folder as MakeAdminShortCut.vbs
:: 

pushd "%~dp0"

if not exist MakePartImage.cmd echo MakePartImage.cmd does not exist in this folder! & pause & goto :EOF
if not exist MakeCmdShortCut.vbs echo MakeCmdShortCut.vbs does not exist in this folder! & pause & goto :EOF
if not exist MakeLinkAdmin.exe echo MakeLinkAdmin.exe does not exist in this folder! & pause & goto :EOF

cscript //nologo MakeCmdShortCut.vbs MakePartImage.cmd MakePartImage.lnk
if exist MakePartImage_AutoRun_FAT32.cmd cscript //nologo MakeCmdShortCut.vbs MakePartImage_AutoRun_FAT32.cmd   MPI_FAT32.lnk
if exist MakePartImage_AutoRun_NTFS.cmd  cscript //nologo MakeCmdShortCut.vbs MakePartImage_AutoRun_NTFS.cmd    MPI_NTFS.lnk

REM Get Desktop path from registry in case user has changed it
REM CHCP 1251 >Nul
for /f "tokens=1,2,*" %%B IN ('reg query "HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\User Shell Folders" /v "Desktop"') do set DESKTOP=%%D
REM CHCP 866 >Nul
for /f "delims=" %%i IN ('echo %DESKTOP%') do set DESKTOP=%%i

REM Change .lnk files to run as Admin
MakeLinkAdmin.exe %DESKTOP%\MakePartImage.lnk
MakeLinkAdmin.exe %DESKTOP%\MPI_FAT32.lnk
MakeLinkAdmin.exe %DESKTOP%\MPI_NTFS.lnk
if not exist "%SystemRoot%\system32\IMDISK.EXE" echo. & echo ImDisk is not yet installed! Please install ImDisk...
if not exist "%SystemRoot%\system32\IMDISK.EXE" call .\imdisk\imdiskinst.exe
if not exist "%SystemRoot%\system32\IMDISK.EXE" echo. & echo ERROR: ImDisk not installed! Please read the ReadMe.txt file. & color cf & pause