@echo off
cls
if "%~1"=="" echo USAGE: Drag-and-drop WIM file onto this .cmd file & pause & goto :EOF
if not "%2"=="am_admin" call powershell -h | find /i "powershell" > nul && if not "%2"=="am_admin" ( cls & powershell start -verb runas '%0' '%1 am_admin' > nul & exit)

:: set cmd shell window size
mode con: cols=120 lines=150

SETLOCAL ENABLEEXTENSIONS
color 1F

cls
echo *******************************
echo *                             *
echo *         MOUNT WIM           *
echo *                             *
echo *******************************
echo.
echo Please Wait - discarding %SystemDrive%\MOUNT4 ...
dism /unmount-wim /mountdir:%SystemDrive%\MOUNT4 /discard > nul
echo.
rd /s /q %SystemDrive%\MOUNT4 > nul
dism /cleanup-wim
::dism /get-wiminfo /wimfile:"%~1"
for /L %%i in (1,1,99) do (
	set NUM=%%i
	dism /Get-ImageInfo /Imagefile:"%~1" /Index:%%i > nul || goto :exit1
)
:exit1
set /a NUM=%NUM%-1
set MAXWIMNUM=%NUM%

cls
echo *******************************
echo *                             *
echo *         MOUNT WIM           *
echo *                             *
echo *******************************
echo.
echo.
echo There are %NUM% images in %~nx1
for /L %%i in (1,1,%NUM%) do (dism /Get-ImageInfo /Imagefile:"%~1" /Index:%%i || goto :exit2)
:exit2
echo.
set WIM=
if not "%NUM%"=="1" set /p WIM=Which image (max=%NUM%, ENTER=abort) : 
if "%NUM%"=="1" set WIM=1
if "%WIM%"=="" goto :EOF
set /a WIM=%WIM%+0
if %WIM% LEQ 0 goto :EOF
if %WIM% GTR %NUM% goto :exit2
goto :done

dism /Get-ImageInfo /Imagefile:"%~1" /Index:2 > %temp%\s.txt
find /i "Wim Bootable :" %temp%\s.txt  > nul
if not errorlevel 1 set WIM=2
if exist %temp%\s.txt del %temp%\s.txt
if not "%WIM%"=="" goto :done

dism /Get-ImageInfo /Imagefile:"%~1" /Index:1 > %temp%\s.txt
find /i "Wim Bootable :" %temp%\s.txt > nul
if not errorlevel 1 set WIM=1
if exist %temp%\s.txt del %temp%\s.txt

:done
mkdir %SystemDrive%\MOUNT4 > nul
echo.
echo.
echo Mounting WIM image #%WIM% at %SystemDrive%\MOUNT4...
echo.
dism /mount-wim /WimFile:"%~1" /index:%WIM% /Mountdir:%SystemDrive%\MOUNT4
echo.
echo WIM FILE - IMAGE #%WIM% MOUNTED in %SystemDrive%\MOUNT4
echo.
echo.
SET BIT=32
if exist "%SystemDrive%\MOUNT4\Program Files (x86)" SET BIT=64
::echo Copying files from %~dp0\Mount folder to %SystemDrive%\MOUNT4 folder...
::if "%BIT%"=="32" xcopy /herky "%~dp0\Files\x86\*.*" "%SystemDrive%\MOUNT4\*.*"
::if "%BIT%"=="64" xcopy /herky "%~dp0\Files\x64\*.*" "%SystemDrive%\MOUNT4\*.*"
::echo.
::echo.
::echo Files\(arch) folder copied to %SystemDrive%\MOUNT4 folder...
echo.
explorer %SystemDrive%\MOUNT4
echo.
echo Close Explorer when finished to prevent errors!

:lp
echo.
set ask=
set gotERR=
set /p ask=Commit or Dismount (C/D) : 
if /i not "%ask%"=="c" if /i not "%ask%"=="d" goto :lp
echo.
if /i "%ask%"=="c" echo Saving changes to WIM file - please wait...
if /i "%ask%"=="d" echo No changes made to WIM file - please wait...
echo.
if /i "%ask%"=="c" dism /unmount-wim /mountdir:%SystemDrive%\MOUNT4 /commit > nul || set gotERR=XX
if /i "%ask%"=="d" dism /unmount-wim /mountdir:%SystemDrive%\MOUNT4 /discard > nul || set gotERR=XX
echo.
if /i "%ask%"=="c" if "%gotERR%"=="XX" echo ERROR: There was a problem saving the wim file - please close all Explorer windows! && pause & goto :lp


:getexp
cls
echo *******************************
echo *                             *
echo *   EXPORT AND COMPRESS WIM   *
echo *                             *
echo *******************************
echo.
set EXPNUM=n
if "%MAXWIMNUM%"=="1" set EXPNUM=1
echo Export an image to %~n1_PE%EXPNUM%.wim with maximum compression to reduce size
echo.
set /p ask=Export which image? (Max=%MAXWIMNUM%, No=0) : 
echo.
set /a EXPNUM=%ask%+0
if %EXPNUM% LEQ 0 goto :cleanup
if %EXPNUM% LEQ %MAXWIMNUM% goto :comp
goto :getexp

:comp
echo.
echo Exporting image #%EXPNUM% to %~n1_PE%EXPNUM%.wim with max-compression + WinPE bootable...
if exist "%~dpn1_PE%EXPNUM%.WIM" del "%~dpn1_PE%EXPNUM%.WIM"
Dism /Export-Image /SourceImageFile:"%~1" /SourceIndex:%EXPNUM% /DestinationImageFile:"%~dpn1_PE%EXPNUM%.WIM" /Compress:max /Bootable || set gotERR=xx
call :psize "%~1"
echo.
echo %~nx1         = %PSIZE%
call :psize "%~dpn1_PE%EXPNUM%.WIM"
echo %~nx1_PE%EXPNUM%.WIM = %PSIZE%
echo.
if not "%MAXWIMNUM%"=="1" pause
if not "%MAXWIMNUM%"=="1" goto :cleanup
set /p ask=Replace %~nx1 (Y/N) : 
echo.
if /i "%ask%"=="y" (
	if exist "%~dpn1_PE%EXPNUM%.WIM" del "%~1"
	if exist "%~dpn1_PE%EXPNUM%.WIM" ren "%~dpn1_PE%EXPNUM%.WIM" "%~nx1" || set gotERR=xx
	) else (
	if exist "%~dpn1_PE%EXPNUM%.WIM" del "%~dpn1_PE%EXPNUM%.WIM" || set gotERR=xx
	)

:cleanup
dism /cleanup-wim > nul
if exist %SystemDrive%\MOUNT4\nul rd /s /q %SystemDrive%\MOUNT4
if exist %SystemDrive%\MOUNT4\nul echo WARNING: %SystemDrive%\MOUNT4 was not deleted. You must close Explorer first! && set gotERR=xx
explorer "%~dp1"
if "%gotERR%"=="" echo SUCCESS! & goto :EOF

echo.
echo.&echo. & pause
goto :EOF

:PSIZE
:: subroutinr to return size of a file in PSIZE
set PSIZE=%~z1
goto :EOF

