@echo off
SETLOCAL ENABLEEXTENSIONS ENABLEDELAYEDEXPANSION
color 1f
cls
pushd "%~dp0"
set mbrfix=mbrfix.exe
if /i "%PROCESSOR_ARCHITECTURE%"=="AMD64" set mbrfix=mbrfix64.exe
if not exist %mbrfix% echo ERROR: CANNOT FIND %mbrfix%& pause & goto :EOF
echo.
echo E2B MBR RESTORE (32 and 64-bit)
echo ===============================
echo.
echo To suppress the user prompt use: %~n0 SURE 
echo. 

call :checkPerms
if "%ADMIN%"=="FAIL" goto :EOF
echo.

::Find CSM 
set USBDRIVE=
set exit=
FOR %%D IN (C D E F G H I J K L M N O P Q R S T U V W X Y Z) DO (
DIR %%D:\e2b\MBR.BIN > nul 2>&1 && (call set USBDRIVE=%%D:) && echo FOUND %%D:\e2b\MBR.BIN
)
echo.
if "%USBDRIVE%"=="" echo CANNOT FIND ANY DRIVE WITH \e2b\MBR.BIN FILE! & pause & goto :end
SET MyVOL=%USBDRIVE%
SET MyDisk=
FOR /F "delims=" %%A IN ('
^(
ECHO Select Volume %MyVol%^&ECHO list disk
^)^|diskpart^|FIND "* "
') DO SET Mydisk=%%A

IF NOT DEFINED MyDisk ECHO ERROR: NO DISK NUMBER FOUND&GOTO :EOF
REM set MyDisk=* Disk 23   Online  298 GB 1024
FOR /F "tokens=1 delims=0123456789" %%A IN ("%MyDisk%") DO SET /A Mydisk=!Mydisk:%%A=! 2>nul
ECHO %MyVol% is on DISK %MyDisk% 
set USB=%MyDisk%
echo.
if "%USB%"=="0" echo WARNING: DISK 0 HAS BEEN SELECTED!
echo.
REM echo DISK %USB% HAS BEEN CHOSEN
%mbrfix% /drive %USB% readdrive 30 1 LBA.BIN
if not exist LBA.BIN echo FILE WRITE ERROR! & pause & goto :EOF
REM %mbrfix% /drive %USB% driveinfo
REM check for validity - if fail use LBA60
find /i "helper" LBA.BIN > nul || %mbrfix% /drive %USB% readdrive 60 1 LBA.BIN
set BAD=
find /i "helper" LBA.BIN > nul || set BAD=1
REM Check has 55hex somewhere
find "U" LBA.BIN > nul || set BAD=1
if defined BAD echo ERROR: Cannot find valid MBR in LBA30 or LBA60& pause & goto :EOF

%mbrfix% /drive %USB% savembr MBR.BAK && echo Disk %USB% MBR saved to file MBR.BAK
if not exist MBR.BAK echo FILE WRITE ERROR! & pause & goto :EOF
echo Writing new MBR to Disk %USB% now...
%mbrfix% /drive %USB% restorembr LBA.BIN /yes 
if /i "%1"=="SURE" (echo RESCAN | diskpart > nul & goto :EOF)

REM Prompt user to check
cls
echo.
echo.
echo To suppress this user prompt use: %~n0 SURE 
echo. 
echo EASY2BOOT PARTITIONS WERE RESTORED OK
echo.
echo USB Partitions are now:
echo.
%mbrfix% /drive %USB% listpartitions
echo.
if "%USB%"=="0" echo WARNING: DISK 0 WAS CHANGED!
echo.
echo Tip: Answer N to restore original MBR...
echo.
set /P ask=Is new MBR now OK? ([Y]/N) : 
if /i not "%ask%"=="N" echo RESCAN | diskpart > nul & goto :EOF
cls
echo.
echo Restoring previous MBR...
%mbrfix% /drive %USB% restorembr MBR.BAK /yes
echo.
%mbrfix% /drive %USB% listpartitions
echo.
echo Original MBR now restored
echo.
pause
goto :EOF



:checkperms
set randname=%random%%random%%random%%random%%random%
md "%windir%\%randname%" 2>nul
if %errorlevel%==0 (echo Administrative permissions confirmed.
goto end)
if %errorlevel%==1 (
    echo Sorry - you need to run as Administrator [use right-click - Run as administrator].
	echo.
	color cf
	pause
	Set ADMIN=FAIL
	goto end)
goto checkperms
:end
rd "%windir%\%randname%" 2>nul
goto :eof
